close all;
clc;

init_cybershipII;

x_L = [0 0];
x_U = [Inf Inf];
t_surge(1:10) = linspace(-8,-5,10)'; % m/s
t_surge(11:30) = linspace(-5,-3,20)'; % m/s
t_surge(31:60) = linspace(-3,-2,30)'; % m/s
t_surge(61:120) = linspace(-2,-1,60)'; % m/s
t_surge(121:220) = linspace(-1,-0,100)'; % m/s
t_surge(221:320) = linspace(0,1,100)'; % m/s
t_surge(321:380) = linspace(1,2,60)'; % m/s
t_surge(381:410) = linspace(2,3,30)'; % m/s
t_surge(411:430) = linspace(3,5,20)'; % m/s
t_surge(431:440) = linspace(5,8,10)'; % m/s

t_surge_linear(1:10) = linspace(-5,-4,10)'; % m/s
t_surge_linear(11:30) = linspace(-4,-3,20)'; % m/s
t_surge_linear(31:60) = linspace(-3,-2,30)'; % m/s
t_surge_linear(61:120) = linspace(-2,-1,60)'; % m/s
t_surge_linear(121:220) = linspace(-1,-0,100)'; % m/s
t_surge_linear(221:320) = linspace(0,1,100)'; % m/s
t_surge_linear(321:380) = linspace(1,2,60)'; % m/s
t_surge_linear(381:410) = linspace(2,3,30)'; % m/s
t_surge_linear(411:430) = linspace(3,4,20)'; % m/s
t_surge_linear(431:440) = linspace(4,5,10)'; % m/s

t_sway(1:10) = linspace(-8,-5,10)'; % m/s
t_sway(11:30) = linspace(-5,-3,20)'; % m/s
t_sway(31:60) = linspace(-3,-2,30)'; % m/s
t_sway(61:120) = linspace(-2,-1,60)'; % m/s
t_sway(121:220) = linspace(-1,0,100)'; % m/s
t_sway(221:320) = linspace(0,1,100)'; % m/s
t_sway(321:380) = linspace(1,2,60)'; % m/s
t_sway(381:410) = linspace(2,3,30)'; % m/s
t_sway(411:430) = linspace(3,5,20)'; % m/s
t_sway(431:440) = linspace(5,8,10)'; % m/s

t_sway_linear(1:10) = linspace(-5,-4,10)'; % m/s
t_sway_linear(11:30) = linspace(-4,-3,20)'; % m/s
t_sway_linear(31:60) = linspace(-3,-2,30)'; % m/s
t_sway_linear(61:120) = linspace(-2,-1,60)'; % m/s
t_sway_linear(121:220) = linspace(-1,0,100)'; % m/s
t_sway_linear(221:320) = linspace(0,1,100)'; % m/s
t_sway_linear(321:380) = linspace(1,2,60)'; % m/s
t_sway_linear(381:410) = linspace(2,3,30)'; % m/s
t_sway_linear(411:430) = linspace(3,4,20)'; % m/s
t_sway_linear(431:440) = linspace(4,5,10)'; % m/s

t_yaw(1:10) = linspace(-5*pi/180,-4*pi/180,10)'; % m/s
t_yaw(11:30) = linspace(-4*pi/180,-3*pi/180,20)'; % m/s
t_yaw(31:60) = linspace(-3*pi/180,-2*pi/180,30)'; % m/s
t_yaw(61:120) = linspace(-2*pi/180,-1*pi/180,60)'; % m/s
t_yaw(121:220) = linspace(-1*pi/180,-0,100)'; % m/s
t_yaw(221:320) = linspace(0,1*pi/180,100)'; % m/s
t_yaw(321:380) = linspace(1*pi/180,2*pi/180,60)'; % m/s
t_yaw(381:410) = linspace(2*pi/180,3*pi/180,30)'; % m/s
t_yaw(411:430) = linspace(3*pi/180,4*pi/180,20)'; % m/s
t_yaw(431:440) = linspace(4*pi/180,5*pi/180,10)'; % m/s

t_yaw_linear(1:10) = linspace(-5*pi/180,-4*pi/180,10)'; % m/s
t_yaw_linear(11:30) = linspace(-4*pi/180,-3*pi/180,20)'; % m/s
t_yaw_linear(31:60) = linspace(-3*pi/180,-2*pi/180,30)'; % m/s
t_yaw_linear(61:120) = linspace(-2*pi/180,-1*pi/180,60)'; % m/s
t_yaw_linear(121:220) = linspace(-1*pi/180,-0,100)'; % m/s
t_yaw_linear(221:320) = linspace(0,1*pi/180,100)'; % m/s
t_yaw_linear(321:380) = linspace(1*pi/180,2*pi/180,60)'; % m/s
t_yaw_linear(381:410) = linspace(2*pi/180,3*pi/180,30)'; % m/s
t_yaw_linear(411:430) = linspace(3*pi/180,4*pi/180,20)'; % m/s
t_yaw_linear(431:440) = linspace(4*pi/180,5*pi/180,10)'; % m/s


Name = 'Surge Damping Parameters - Surge Speed';
[y_real_surge_surge, y_est_surge_surge, p_est_surge_surge] = decoupled_pe(-cs.X_u,-cs.X_uu,-cs.X_uuu,Name,x_L,x_U,t_surge);
Name = 'Surge Damping Parameters - Surge Speed';
[y_real_surge_surge, y_est_surge_surge_linear, p_est_surge_surge_linear] = decoupled_pe_linear(-cs.X_u,-cs.X_uu,-cs.X_uuu,Name,0,Inf,t_surge_linear);

Name = 'Sway Damping Parameters - Sway speed';
[y_real_sway_sway, y_est_sway_sway, p_est_sway_sway] = decoupled_pe(-cs.Y_v,-cs.Y_vv,0,Name,x_L,x_U,t_sway);
Name = 'Sway Damping Parameters - Sway speed';
[y_real_sway_sway, y_est_sway_sway_linear, p_est_sway_sway_linear] = decoupled_pe_linear(-cs.Y_v,-cs.Y_vv,0,Name,0,Inf,t_sway_linear);


Name = 'Sway Damping Parameters - Yaw speed';
[y_real_sway_yaw, y_est_sway_yaw, p_est_sway_yaw] = decoupled_pe(-cs.Y_r,-cs.Y_rr,0,Name,x_L,x_U,t_yaw);
Name = 'Sway Damping Parameters - Yaw speed';
[y_real_sway_yaw, y_est_sway_yaw_linear, p_est_sway_yaw_linear] = decoupled_pe_linear(-cs.Y_r,-cs.Y_rr,0,Name,0,Inf,t_yaw_linear);


Name = 'Yaw Damping Parameters - Sway speed';
[y_real_yaw_sway, y_est_yaw_sway, p_est_yaw_sway] = decoupled_pe(-cs.N_v,-cs.N_vv,0,Name,x_L,x_U,t_sway);
Name = 'Yaw Damping Parameters - Sway speed';
[y_real_yaw_sway, y_est_yaw_sway_linear, p_est_yaw_sway_linear] = decoupled_pe_linear(-cs.N_v,-cs.N_vv,0,Name,-Inf,Inf,t_sway_linear);


Name = 'Yaw Damping Parameters - Yaw speed';
[y_real_yaw_yaw, y_est_yaw_yaw, p_est_yaw_yaw] = decoupled_pe(-cs.N_r,-cs.N_rr,0,Name,x_L,x_U,t_yaw);
Name = 'Yaw Damping Parameters - Yaw speed';
[y_real_yaw_yaw, y_est_yaw_yaw_linear, p_est_yaw_yaw_linear] = decoupled_pe_linear(-cs.N_r,-cs.N_rr,0,Name,0,Inf,t_yaw_linear);


figure(1)
subplot(3,1,1)
hold on;
plot(t_surge,y_real_surge_surge,'b-');
plot(t_surge,y_est_surge_surge,'r-')
plot(t_surge,y_est_surge_surge_linear,'g-')
xlabel('Surge speed [m/s]');
ylabel('Damping force in surge direction');
legend('2. order modulus damping','Abkowitz damping','Linear damping');

subplot(3,1,2)
hold on;
plot(t_sway,y_real_sway_sway,'b-');
plot(t_sway,y_est_sway_sway,'r-')
plot(t_sway,y_est_sway_sway_linear,'g-')
xlabel('Sway speed [m/s]');
ylabel('Damping force in sway direction');
legend('2. order modulus damping','Abkowitz damping','Linear damping');

subplot(3,1,3)
hold on;
plot(t_yaw,y_real_yaw_yaw,'b-');
plot(t_yaw,y_est_yaw_yaw,'r-')
plot(t_yaw,y_est_yaw_yaw_linear,'g-')
xlabel('Yaw rate [rad/s]');
ylabel('Damping moment in yaw direction');
legend('2. order modulus damping','Abkowitz damping','Linear damping');

figure(2)
subplot(2,1,1)
hold on;
plot(t_yaw,y_real_sway_yaw,'b-');
plot(t_yaw,y_est_sway_yaw,'r-')
plot(t_yaw,y_est_sway_yaw_linear,'g-')
xlabel('Yaw rate [rad/s]');
ylabel('Damping force in sway direction');
legend('2. order modulus damping','Abkowitz damping','Linear damping');

subplot(2,1,2)
hold on;
plot(t_sway,y_real_yaw_sway,'b-');
plot(t_sway,y_est_yaw_sway,'r-')
plot(t_sway,y_est_yaw_sway_linear,'g-')
xlabel('Sway speed [m/s]');
ylabel('Damping moment in yaw direction');
legend('2. order modulus damping','Abkowitz damping','Linear damping');





