function eta_cdotdot = dfun_sim(eta_cdot,LP,eta_cdot_0)
% Current dynamics. Modeled as Low-Pass filtered random walk.
% eta_cdot = dfun_sim(eta_cdot,LP,eta_cdot_0)
%
% INPUT:
% eta_cdot = [V_c; beta_c];
% LP = [Tbvv; Tbbb];
% eta_cdot_0 = [V_c_0; beta_c_0];
%
% OUTPUT:
% eta_cdot = [V_c_0_dot; beta_c_0_dot]

Tbvv = LP(1);
Tbbb = LP(2);

V_c_0 = eta_cdot_0(1);
beta_c_0 = eta_cdot_0(2);

V_c = eta_cdot(1);
beta_c = eta_cdot(2);

eta_cdotdot = [-1/Tbvv*(V_c - V_c_0); -1/Tbbb*(beta_c - beta_c_0)];  
