function [F,L] = ffun_sw_jacobian(x,input,d)

global cs

w_0x = 0.8;
w_0y = 0.8;
w_0psi = 0.8;
lambda_x = 0.26;
lambda_y = 0.26;
lambda_psi = 0.26;
T_x = 500;
T_y = 500;
T_psi = 500;

T_inv = diag([1/T_x 1/T_y 1/T_psi]);

Aw = [zeros(3) eye(3);
      diag([-w_0x^2 -w_0y^2 -w_0psi^2]) diag([-2*lambda_x*w_0x -2*lambda_y*w_0y -2*lambda_psi*w_0psi])];
  
Ax = jacobi_modulus(x(1:6),d);

F = zeros(15,15);
F(1:6,1:6) = Ax; 


s_psi = sin(x(3));
c_psi = cos(x(3));

R_trans = [c_psi s_psi 0;
           -s_psi c_psi 0;
           0    0   1];

DR_psiDpsi_trans = [-s_psi c_psi   0;
                    -c_psi -s_psi  0;
                    0      0       0];

F(4:6,3) = F(4:6,3) + cs.M_inv*DR_psiDpsi_trans*x(15:17); %b
F(4:6,13:15) = cs.M_inv*R_trans; %b

F(9:14,9:14) = Aw;
F(13:15,13:15) = -T_inv;


L = zeros(15,6);
L(10:12,1:3) = eye(3);
L(13:15,4:6) = eye(3);