function y = hfun_pose_waves(x,w)
% Measurement function. 
% 
% Input:
% x - states
%  x(1:3) = eta
%  x(4:6) = nu
%  x(7:12) = xi
% w - noise
%
% OUTPUT:
% y - Measured output value

m = size(x,2);
if w == 0
    w = zeros(3,m);
elseif ~(size(w,1) + size(w,1))
    w = zeros(3,m);
end



y = x(1:3,:) + w(1:3,:) + x(10:12,:);