function y = hfun_pose_waves_eigen(x,w)
% Measurement function. 
% 
% Input:
% x - states
%  x(1:3) = eta
%  x(4:6) = nu
%  x(7:8) = eta_cdot
%  x(9:14) = xi
% w - noise
%
% OUTPUT:
% y - Measured output value

m = size(x,2);
if w == 0
    w = zeros(3,m);
elseif ~(size(w,1) + size(w,1))
    w = zeros(3,m);
end

y = x(1:3,:) + w(1:3,:) + x(9:11,:);