function tull = plot_disturbances(t,disturbance,pattern,n)

[n_c,n_r] = size(disturbance);
if n_c == 2
    disturbance = [disturbance(1:2,:); zeros(2,n_r)];
    for k = 1:n_r
        disturbance(3,k) = sqrt(disturbance(1,k)^2 + disturbance(2,k)^2); 
        disturbance(4,k) = atan2(disturbance(2,k),disturbance(1,k));
    end
end
    

figure(n)
subplot(4,1,1)
title('Comparison of simulated and estimated current')
hold on;
plot(t,disturbance(1,:),pattern);
xlabel('t [s]');
ylabel('d(x_c)/dt [m/s]');
legend('Simulated','UKF1','UKF2','EKF');

subplot(4,1,2)
hold on;
plot(t,disturbance(2,:),pattern);
xlabel('t [s]');
ylabel('d(y_c)/dt [m/s]');
legend('Simulated','UKF1','UKF2','EKF');

subplot(4,1,3)
hold on;
plot(t,disturbance(3,:),pattern);
xlabel('t [s]');
ylabel('V_c [m/s]');
legend('Simulated','UKF1','UKF2','EKF');

subplot(4,1,4)
hold on;
plot(t,disturbance(4,:)*180/pi,pattern);
xlabel('t [s]');
ylabel('\beta_c [deg]');
legend('Simulated','UKF1','UKF2','EKF');

% 
% figure(n+1)
% subplot(3,1,1)
% title('Comparison of simulated Froude Krilov forces and wave drift forces and estimated force bias')
% hold on;
% plot(t,disturbance(5,:),pattern);
% legend('Simulated','UKF1','UKF2','EKF');
% xlabel('t [s]');
% ylabel('\tau_{wx} [kgm/s^2]');
% 
% subplot(3,1,2)
% hold on;
% plot(t,disturbance(6,:),pattern);
% legend('Simulated','UKF1','UKF2','EKF');
% xlabel('t [s]');
% ylabel('\tau_{wy} [kgm/s^2]');
% 
% subplot(3,1,3)
% hold on;
% plot(t,disturbance(7,:),pattern);
% legend('Simulated','UKF1','UKF2','EKF');
% xlabel('t [s]');
% ylabel('\tau_{w\psi} [kg(m/s)^2]');

tull = 0;

