function tull = plot_states_controller(t,states,pattern,n)
% Plots estimate
%
%
% INPUT:
%
%
% OUTPUT:
% void, nothing...

%% Creating plots
figure(n)
subplot(3,3,1:3)
title('Comparison of reference and controlled state');
hold on;
plot(states(2,:),states(1,:),pattern);
xlabel('y - East [m]');
ylabel('x - North [m]');
legend('Reference','Controlled state');

subplot(3,3,4)
hold on;
plot(t,states(1,:),pattern);
xlabel('Time [s]');
ylabel('x - North [m]');
legend('Reference','Controlled state');

subplot(3,3,5)
hold on;
plot(t,states(2,:),pattern);
xlabel('Time [s]');
ylabel('y - East [m]');
legend('Reference','Controlled state');

subplot(3,3,6)
hold on;
plot(t,states(3,:)*180/pi,pattern);
xlabel('Time [s]');
ylabel('\psi - Yaw [deg]');
legend('Reference','Controlled state');
if size(states,1) > 3
    subplot(3,3,7)
    hold on;
    plot(t,states(4,:),pattern);
    xlabel('Time [s]');
    ylabel('u - Surge speed [m/s]');
legend('Controlled state');

    subplot(3,3,8)
    hold on;
    plot(t,states(5,:),pattern);
    xlabel('Time [s]');
    ylabel('v - Sway speed [m/s]');
legend('Controlled state');

    subplot(3,3,9)
    hold on;
    plot(t,states(6,:)*180/pi,pattern);
    xlabel('Time [s]');
    ylabel('r - Yaw rate [deg/s]');
    legend('Controlled state');
end
tull = 0;