function tull = plot_states_est(t,states,pattern,n)
% Plots estimate
% 
%
% INPUT:
%
%
% OUTPUT:
% void, nothing...

%% Creating plots
figure(n)
subplot(3,3,1:3)
hold on;
plot(states(2,:),states(1,:),pattern);
title('Comparison of simulated vessel state and estimated vessel state');
xlabel('y - East [m]');
ylabel('x - North [m]');
legend('Simulated','UKF1','UKF2','EKF');


subplot(3,3,4)
hold on;
plot(t,states(1,:),pattern);
legend('Simulated','UKF1','UKF2','EKF');
xlabel('Time [s]');
ylabel('x - North [m]');


subplot(3,3,5)
hold on;
plot(t,states(2,:),pattern);
legend('Simulated','UKF1','UKF2','EKF');
xlabel('Time [s]');
ylabel('y - East [m]');


subplot(3,3,6)
hold on;
plot(t,states(3,:)*180/pi,pattern);
legend('Simulated','UKF1','UKF2','EKF');
xlabel('Time [s]');
ylabel('\psi - Yaw [deg]');



subplot(3,3,7)
hold on;
plot(t,states(4,:),pattern);
legend('Simulated','UKF1','UKF2','EKF');
xlabel('Time [s]');
ylabel('u - Surge speed [m/s]');


subplot(3,3,8)
hold on;
plot(t,states(5,:),pattern);
xlabel('Time [s]');
ylabel('v - Sway speed [m/s]');
legend('Simulated','UKF1','UKF2','EKF');

subplot(3,3,9)
hold on;
plot(t,states(6,:)*180/pi,pattern);
xlabel('Time [s]');
ylabel('r - Yaw rate [deg/s]');
legend('Simulated','UKF1','UKF2','EKF');

tull = 0;