if k == 1
    % Functions
    pe_algorithm = Prob.estimation.pe_algorithm;
    pe_states_function = Prob.estimation.pe_states_function;
    pe_measurement_function = Prob.estimation.pe_measurement_function;
    pe_integrator = Prob.estimation.pe_integrator;
    pe_constraints = Prob.estimation.pe_constraints;
    
    % Covariance 
    pe_R = Prob.estimation.pe_R; % Process noise covariance

    
    result.P_ukf_abko = zeros(4,4,samples);
    result.P_ukf_abko(:,:,1) = Prob.estimation.P_0;
    result.p_ukf_abko = zeros(4,samples);
    
    if strcmp(Prob.estimation.S_ESTIMATE_OFFLINE,'On')
        states = 'result.x_ukf_offline{1}(1:6,k-1)';
    else
        states = 'result.x_sim(:,k-1)';
    end

    if strcmp(Prob.estimation.D_ESTIMATE_OFFLINE,'On')
        current = 'result.x_ukf_offline{1}(7:8,k-1)';
    else
        current = 'result.d_sim_ned(:,k-1)';
    end
    
    if strcmp(Prob.estimation.B_ESTIMATE_OFFLINE,'On')
        bias = 'result.x_ukf_offline{1}(15:17,k-1)';
    else
        bias = 'zeros(3,1)';
    end
        
else
    if strcmp(Prob.estimation.pe_tuning,'Adaptive')
        pe_Q = (Prob.estimation.pe_Q_tuning^-1 - 1)*result.P_ukf_abko(:,:,k-1);    
    else
        pe_Q = Prob.estimation.pe_Q;
    end
    [result.p_ukf_abko(:,k),result.P_ukf_abko(:,:,k)] = feval(...
        pe_algorithm, pe_integrator, pe_states_function, pe_measurement_function, pe_constraints,...
        result.y_sim_pose(:,k), result.p_ukf_abko(:,k-1), [result.u(:,k-1); eval(current); eval(bias)],...
        eval(states), result.P_ukf_abko(:,:,k-1),pe_Q,pe_R,99,Ts);
end
