if k == 1
    % Functions
    pe_al = Prob.estimation.pe_algorithm;
    pe_st_fu = Prob.estimation.pe_states_function;
    pe_me_fu = Prob.estimation.pe_measurement_function;
    pe_in = Prob.estimation.pe_integrator;
    pe_co = Prob.estimation.pe_constraints;

    % Covariance
    pe_R = Prob.estimation.pe_R; % Process noise covariance

    result.P_ukf_abko = zeros(4,4,samples);
    result.P_ukf_abko(:,:,1) = Prob.estimation.P_0;
    result.p_ukf_abko = zeros(4,samples);


else

    if strcmp(Prob.estimation.PE_ONLINE,'On')
        if strcmp(Prob.estimation.S_ONLINE_ESTIMATE,'On')
            states = result.x_ukf_online(1:6,k-1);
        end

        if strcmp(Prob.estimation.D_ONLINE_ESTIMATE,'On')
            current = result.x_ukf_online(7:8,k-1);
        end

        if strcmp(Prob.estimation.B_ONLINE_ESTIMATE,'On')
            bias = result.x_ukf_online(9:11,k-1);
        end
    elseif strcmp(Prob.estimation.PE_ONLINE,'On')
        if strcmp(Prob.estimation.S_OFFLINE_ESTIMATE,'On')
            states = result.x_ukf_offline(1:6,k-1);
        end

        if strcmp(Prob.estimation.D_OFFLINE_ESTIMATE,'On')
            current = result.x_ukf_offline(7:8,k-1);
        end

        if strcmp(Prob.estimation.B_OFFLINE_ESTIMATE,'On')
            bias = result.x_ukf_offline(9:11,k-1);
        end
    else
        states = result.x_sim(:,k-1);
        current = result.d_sim_ned(:,k-1);
        bias = zeros(3,1);
    end

    if strcmp(Prob.estimation.pe_tuning,'Adaptive')
        pe_Q = (Prob.estimation.pe_Q_tuning^-1 - 1)*result.P_ukf_abko(:,:,k-1);    
    else
        pe_Q = Prob.estimation.pe_Q;
    end
    [result.p_ukf_abko(:,k),result.P_ukf_abko(:,:,k)] =...
    feval(pe_al, pe_in, pe_st_fu, pe_me_fu, pe_co, result.y_sim_pose(:,k),...
        result.p_ukf_abko(:,k-1), [Prob.controller.u(:,k-1); current; bias],...
        states, result.P_ukf_abko(:,:,k-1),pe_Q,pe_R,2,Ts);
end
