
if k == 1
    if strcmp(Prob.estimation.S_ESTIMATE_ONLINE,'On')
        eta = result.x_ukf_online(1:3,k);
        nu = result.x_ukf_online(4:6,k);
        psi = eta(3);
    else
        eta = result.x_sim(1:3,k);
        nu = result.x_sim(4:6,k);
        psi = result.x_sim(3,k);
    end
    error_int = zeros(3,1);
    Kp = Prob.controller.Kp;
    Ki = Prob.controller.Ki;
    Kd = Prob.controller.Kd;
    nu_lp = nu;
    eta_error = eta - result.ref_sim(1:3,k);
else
    if strcmp(Prob.estimation.S_ESTIMATE_ONLINE,'On')
        eta = result.x_ukf_online(1:3,k);
        nu = result.x_ukf_online(4:6,k);
        if k > 1
            nu_1 = result.x_ukf_online(4:6,k-1);
        else
            nu_1 = zeros(3,1);
        end
        if k > 2
         nu_2 = result.x_ukf_online(4:6,k-2);
        else 
            nu_2 = zeros(3,1);
        end
        psi = eta(3);
    else
        eta = result.x_sim(1:3,k);
        nu = result.x_sim(4:6,k);
        if k > 1
            nu_1 = result.x_sim(4:6,k-1);
        else
            nu_1 = zeros(3,1);
        end
        if k > 2
         nu_2 = result.x_sim(4:6,k-2);
        else 
            nu_2 = zeros(3,1);
        end
        psi = result.x_sim(3,k);
    end
    eta_error = eta - result.ref_sim(1:3,k);
    error_int = error_int + Ts*(0.5*eta_error + 0.5*(eta - result.ref_sim(1:3,k-1)));
    nu_lp = (3*nu + 2*nu_1 + nu_2)/6;

end

c_psi = cos(psi); s_psi = sin(psi); R_psit = [c_psi s_psi 0; -s_psi c_psi 0; 0 0 1];
if strcmp(Prob.estimation.B_ESTIMATE_ONLINE,'On')
    % Rotation matrix for forces
    b_body = R_psit*eval(Prob.estimation.bias);
else
    b_body = zeros(3,1);
end

u = - R_psit*(Kp*eta_error + Ki*error_int + Kd*R_psit'*nu_lp);% - b_body;
