% Calculates estimator performance.

if strcmp(Prob.estimation.UKF_ONLINE,'On') || strcmp(Prob.estimation.UKF_OFFLINE,'On')
    ukf_estimate_error = cell(1,n_ukf);
    for ukf_number = 1:n_ukf
        ukf_estimate_error{ukf_number} = zeros(n_x,samples);
        for m = 1:n_x
            ukf_estimate_error{ukf_number}(m,:) = Prob.result.x_ukf{ukf_number}(m,:)-Prob.result.x_sim(m,:);
            Prob.result.avg_RMS_ukf{ukf_number}(m) = ukf_estimate_error{ukf_number}(m,:)*ukf_estimate_error{ukf_number}(m,:)'/samples;
        end
    end
end

if strcmp(Prob.estimation.EKF_OFFLINE,'On')
    ekf_estimate_error = zeros(n_x,samples);
    for m = 1:n_x
        ekf_estimate_error(m,:) = Prob.result.x_ekf(m,:)-Prob.result.x_sim(m,:);
        Prob.result.avg_RMS_ekf(m) = ekf_estimate_error(m,:)*ekf_estimate_error(m,:)'/samples;
    end

end